<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="100px"
    >
      <el-form-item label="课程类型名称" prop="ctType">
        <el-input
          v-model="queryParams.ctType"
          placeholder="请输入课程类型名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="课程类型节点" prop="ctTypeNode">
        <el-select
          v-model="queryParams.ctTypeNode"
          placeholder="请选择类型节点类型"
          clearable
          class="!w-240px"
          @change="handleQuery"
        >
          <el-option label="主题" value="0" />
          <el-option label="类型" value="1" />
        </el-select>
      </el-form-item>
      <el-form-item label="课程类型描述" prop="ctTypeDescribe">
        <el-input
          v-model="queryParams.ctTypeDescribe"
          placeholder="请输入课程类型描述"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['blockly:blockly-type:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['blockly:blockly-type:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
        <el-button type="danger" plain @click="toggleExpandAll">
          <Icon icon="ep:sort" class="mr-5px" /> 展开/折叠
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table
      v-loading="loading"
      :data="list"
      :stripe="true"
      :show-overflow-tooltip="true"
      row-key="id"
      :default-expand-all="isExpandAll"
      v-if="refreshTable"
    >
      <el-table-column label="课程类型名称" align="center" prop="ctType" />
      <el-table-column label="节点类型" align="center" prop="ctTypeNode" >
        <template #default="scope">
          <el-tag type="info" v-if="scope.row.ctTypeNode === '0'">主题</el-tag>
          <el-tag type="warning" v-else>类型</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="封面" align="center" prop="ctTypeImage" >
        <template #default="scope">
          <img :src="scope.row.ctTypeImage" class="w-150px"/>
        </template>
      </el-table-column>
      <el-table-column label="课程类型描述" align="center" prop="ctTypeDescribe" />
      <el-table-column label="排序" align="center" prop="ctTypeSort" />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            v-if="scope.row.tenantId == getTenantId()"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['blockly:blockly-type:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            v-if="scope.row.tenantId == getTenantId() && scope.row.ctTypeNode == '0'"
            @click="openForm('create', undefined, scope.row.id)"
            v-hasPermi="['blockly:blockly-type:create']"
          >
            新增
          </el-button>
          <el-button
            link
            type="danger"
            v-if="scope.row.tenantId == getTenantId()"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['blockly:blockly-type:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <BlocklyTypeForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { handleTree } from '@/utils/tree'
import download from '@/utils/download'
import { BlocklyTypeApi, BlocklyTypeVO } from '@/api/blockly/blocklyType'
import BlocklyTypeForm from './BlocklyTypeForm.vue'
import { ElButton } from 'element-plus'
import { getTenantId } from '@/utils/auth'

/** 课程-类型 列表 */
defineOptions({ name: 'BlocklyType' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<BlocklyTypeVO[]>([]) // 列表的数据
const queryParams = reactive({
  ctType: undefined,
  ctTypeNode: undefined,
  ctParentId: undefined,
  ctTypeDescribe: undefined
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await BlocklyTypeApi.getBlocklyTypeList(queryParams)
    list.value = handleTree(data, 'id', 'ctParentId')
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number, parentId?: number) => {
  formRef.value.open(type, id, parentId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await BlocklyTypeApi.deleteBlocklyType(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await BlocklyTypeApi.exportBlocklyType(queryParams)
    download.excel(data, '课程-类型.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 展开/折叠操作 */
const isExpandAll = ref(true) // 是否展开，默认全部展开
const refreshTable = ref(true) // 重新渲染表格状态
const toggleExpandAll = async () => {
  refreshTable.value = false
  isExpandAll.value = !isExpandAll.value
  await nextTick()
  refreshTable.value = true
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
